#pragma once

#include "ActorInterface.h"
#include "wascommand.h"
#include "WASActor.h"

class CWASGetNewRoom :
	public CWASCommand
{
public:
	CWASGetNewRoom(CWASActor *pActor);
	~CWASGetNewRoom(void);

	void ExecuteAsync(void);

	void SetParameter(LPCWSTR pszUserID, LPCWSTR pszUserName, LPCWSTR pszBuddyID, LPCWSTR pszBuddyName)
	{
		m_wsUserID = pszUserID;
		m_wsUserName = pszUserName;
		m_wsChatBuddyID = pszBuddyID;
		m_wsChatBuddyName = pszBuddyName;
	}


private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:

	WSTRING m_wsUserID;
	WSTRING m_wsUserName;
	WSTRING m_wsChatBuddyID;
	WSTRING m_wsChatBuddyName;
	P_GT_ROOM_DATA m_sRoomInfo;	
//	bool m_bUpdatedFavorite;
};
